<?php

function brisqq_sm_custom_class_carrier() {
	class Brisqq_Carrier_Custom_Code extends Brisqq_Carrier_Core {

		public function calculate_shipping ($package=array()) {
			global $woocommerce;

			$price_only = filter_var($woocommerce->cart->get_cart_subtotal(false), FILTER_SANITIZE_NUMBER_FLOAT, FILTER_FLAG_ALLOW_FRACTION);

			$price_only = str_replace('-', '', $price_only);

			$cartGrossTotal = $price_only;

			$partnerPricesRules = rawurldecode($this->settings['Brisqq_rules_input']);
			$matchedDistance = $this->_deliveryData['matchedDistance'];
			$price = $this->_deliveryData['price'];
			$partnerPrices = $this->settings['Brisqq_tiers_input'];
			//



			if (isset($partnerPrices)) {
				$partnerpriceserialized = explode('&', $partnerPrices);
			}

			if (isset($partnerPricesRules)) {
				$pricesRulesSerialized = explode('&', htmlspecialchars_decode($partnerPricesRules));
			}


			$moreLessRule = array();
			if (isset($partnerpriceserialized)) {
				foreach ($partnerpriceserialized as $value) {
					$customerpricetiers = explode('=', $value);
					if (isset($customerpricetiers[1]) && $customerpricetiers[1] !== "" && $customerpricetiers[1] !== " " && $customerpricetiers[0] == $matchedDistance) {
						$GLOBALS['brisqqShowTierPrice'] = $customerpricetiers[1];
					}
				}
			}


			if (isset($GLOBALS['brisqqShowTierPrice'])) {
				$showprice = $GLOBALS['brisqqShowTierPrice'];
			} else {
				$showprice = $price;
			}

			if (!empty($showprice)) {
				//
				if (isset($pricesRulesSerialized) && $pricesRulesSerialized[0] != "") {
					foreach ($pricesRulesSerialized as $key => $eachRule) {
						if (strpos($eachRule, '=') !== false) {
							$equalRule = explode("=", $eachRule);
							if ($equalRule[0] == $cartGrossTotal) {
								if (strpos($equalRule[1], '%') !== false) {
									$priceOnly = explode('%', $equalRule[1]);
									$newprice = round($showprice * ((100 - $priceOnly[0]) / 100), 2);
									$showprice = $newprice;
									$this->add_rate( array(
										'id' => $this->id,
										'label' => $this->title,
										'cost' => $showprice,
									));
									return;
								} else {
									$showprice = $equalRule[1];
									$this->add_rate( array(
										'id' => $this->id,
										'label' => $this->title,
										'cost' => $showprice,
									));
									return;
								}
							}
						}

						if (strpos($eachRule, '>') !== false) {
							$moreRule = explode(">", $eachRule);
							if ($moreRule[0] <= $cartGrossTotal) {
								$moreLessRule[] = $moreRule;
							}
						}

						if (strpos($eachRule, '<') !== false) {
							$lessRule = explode("<", $eachRule);
							if ($lessRule[0] >= $cartGrossTotal) {
								$moreLessRule[] = $lessRule;
							}
						}

					}

					if (isset($moreLessRule) && !empty($moreLessRule)) {
						$finalRule = $moreLessRule[0];


						if (strpos($finalRule[1], '%') !== false) {
							$priceOnly = explode('%', $finalRule[1]);
							$newprice = round($showprice * ((100 - $priceOnly[0]) / 100), 2);
							$showprice = $newprice;
							$GLOBALS['saveRulePrice'] = $newprice;
						} else {
							$showprice = $finalRule[1];
							$GLOBALS['saveRulePrice'] = $finalRule[1];
						}
					}
				}
			}


			// send the final rate to the user.
			$this->add_rate( array(
				'id' => $this->id,
				'label' => $this->title,
				'cost' => $showprice,
			));

		}
	}
}


function brisqq_sm_custom_class_observer() {
	class Brisqq_Observer_Custom_Code extends Brisqq_Observer {

	}
}

?>